<?php
namespace Teknisa\SM\Factory;
use Doctrine\ORM\EntityManager;

class Sm00048000ImpostoFactory{
    protected $connection;
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    /**
     * Deleta um imposto
    **/
    public function deleteImposto(array $params){
        $sql = "DELETE FROM FCT_RELACIMPOSTOSERV
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Deleta alguns servicos do imposto
    **/
    public function deleteServicoImposto(array $params, $nrimposto){
        $sql = "DELETE FROM FCT_RELACIMPOSTOSERV
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG
                    AND NRIMPOSTOSERV IN($nrimposto)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    /**
     * Salva a edição de um imposto relacionado a um serviço
    **/
    public function salvarEdicaoImposto(array $params){
        $sql = "UPDATE FCT_RELACIMPOSTOSERV
                SET VRPRECIMPOSTO = :VRPRECIMPOSTO
                WHERE CDIMPOSTO = :CDIMPOSTO
                    AND NRORG   = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}
?>