/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3907_CDPFUNO.SQL

Descrio:
Funo para retornar a data de validade do produto.

Criao:
18/01/2005 - Fabrcio Marcelo da Silva

@..\Sql\End_Conv\SQLSERVER\3907_CDPFUNO.SQL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'VALIDADE_PRODUTO' AND
                 TYPE = 'FN' 		     AND
	              U.UID = O.UID          AND
	              U.NAME = USER)
DROP FUNCTION VALIDADE_PRODUTO
GO
CREATE FUNCTION VALIDADE_PRODUTO(
   @P_CDPRODUTO  VARCHAR(10),
   @P_DTENTRPROD DATETIME) RETURNS DATETIME
AS BEGIN
   DECLARE @V_IDDIASVALIDA  VARCHAR(1);
   DECLARE @V_NRDIASVALIDA  NUMERIC;
   DECLARE @V_QTDEVALID     NUMERIC;
   DECLARE @V_DTENTREGA     DATETIME;

   SET @V_IDDIASVALIDA = NULL;
   SET @V_NRDIASVALIDA = 0;

   SELECT
      @V_IDDIASVALIDA = ISNULL(MAX(IDDIASVALIDA),0),
      @V_NRDIASVALIDA = ISNULL(MAX(NRDIASVALIDA),0)
   FROM
      PRODUTO
   WHERE
      (CDPRODUTO = @P_CDPRODUTO);

   IF @V_IDDIASVALIDA = 'H' BEGIN     /* Validade em Horas */
      SET @V_QTDEVALID = ((@V_NRDIASVALIDA * 60) / 1440);
   END
   ELSE BEGIN
      IF @V_IDDIASVALIDA = 'M' BEGIN  /* Validade em Meses */
         --SET @V_QTDEVALID = (@V_NRDIASVALIDA * 30);
         SET @V_DTENTREGA = DATEADD(MONTH, @V_NRDIASVALIDA, @P_DTENTRPROD);
      END
      ELSE BEGIN
         SET @V_QTDEVALID = @V_NRDIASVALIDA;
      END;
   END;

   IF @V_IDDIASVALIDA <> 'M' BEGIN
      SET @V_DTENTREGA = @P_DTENTRPROD + @V_QTDEVALID;
   END;

   RETURN(@V_DTENTREGA);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'VALIDADE_PRODUTO','6.19.130';
GO

